#ifdef QT_WINDOW

#include "hivewindow.h"
#include "hive.h"
#include "vanillahive.h"
#include "settings.h"

#include <QTimerEvent>

Hive* hive;

HiveWindow::HiveWindow(QWidget *parent, Qt::WFlags flags)
    : QGLWidget(parent, 0, flags)
{
	loadsettings();
	frametimer = startTimer( 10 );
	eventtimer = startTimer( settings.eventms );
}

HiveWindow::~HiveWindow()
{

}

void HiveWindow::initializeGL()
{
	hive = new VanillaHive( width(), height() );
}

void HiveWindow::paintGL()
{
	hive->step();
	hive->paint();
}

void HiveWindow::resizeGL( int w, int h )
{
	if ( hive ) hive->setSize( w, h );
}

void HiveWindow::timerEvent( QTimerEvent* e )
{
	if ( e->timerId() == frametimer )
	{
		update();
	}
	if ( e->timerId() == eventtimer )
	{
		hive->doEvent();
	}
}

void HiveWindow::keyPressEvent(QKeyEvent*)
{
	hive->doEvent();
}

#endif
